.include "src/config/config.inc"


;defines
.define maxNumberOopObjs	36
;.define oopArrayLength 9
.define oopStackTst	$aa55
.define maxExecTime 10	;number of frames oop handler may spend on a single obj before nmi watchdog throws error

;obj return codes
.ENUM 0	export
OBJR_noErr	db
OBJR_kill	db
.ende

;zp-vars,just a reference
.enum 0
  iterator INSTANCEOF iteratorStruct
zpLen ds 0
.ende

;oop structures
.STRUCT oopStackObj
flags		db	;@see OBJECT.FLAGS
id			db	;class id
num			dw	;number of core.object.create calls at obj instanciation time. used for fingerprint
;pntr		ds 3	;24bit pointer to obj in rom. needed? may be removed
void		dw
properties	dw
dp			dw	;absolute direct page adress on object variable buffer
init		dw	;obj init subroutine absolute adress
play		dw	;obj play subroutine absolute adress
kill		dw	;obj terminate subroutine absolute adress
.ENDST

.def oopStackObj.length _sizeof_oopStackObj
.export oopStackObj.length

;changing the enum below means you'll also have to modfiy the macro that generates objects
.ENUM 0	export
OOPR.flags	db	;bit0: singleton
OOPR.id			db	;generated by saving number of class macro calls here
OOPR.zpLen	db	;length of required zeropage-buffer
OOPR.properties dw	;property flags
OOPR.rCount	db	;number of routines
OOPR.nClass	db	;relative adress of obj class name
OOPR.rInit	dw	;adress of obj init routine
OOPR.nInit	db	;relative adress of obj init routine name
OOPR.rPlay	dw 	;adress of obj play routine
OOPR.nPlay	db	;relative adress of obj play routine name
OOPR.rKill	dw 	;adress of obj terminate routine
OOPR.nKill	db	;relative adress of obj terminate routine name
OOPR.rAdd		dw 	;adress of obj additional routine
OOPR.nAdd		db	;relative adress of obj additional routine name
.ENDE

.enum 0
Hash INSTANCEOF oopObjHash
.ende

;ram buffers
.ramsection "oop ram" bank 0 slot 1
OopStack INSTANCEOF oopStackObj maxNumberOopObjs
OopStackEnd ds 0
.ends

;ram buffers
.ramsection "global oop vars" bank 0 slot 1
GLOBAL.currentObject	dw	;class number of current (last processed) object
GLOBAL.currentMethod	dw	;number of current (last called) method
GLOBAL.currentClass		dw	;class number of current (last called) method

GLOBAL.currentObjectStr		ds 3
GLOBAL.currentMethodStr			ds 3
GLOBAL.currentClassStr		ds 3
GLOBAL.garbagePresent	dw
GLOBAL.execFrame		dw
.ends



.ramsection "oop obj ram zp" bank 0 slot 2
OopObjRam ds $1800
OopObjRamEnd ds 0
.ends

;spit out globally unique obj-ids. order does not matter. reason for this hack is that wla dx is unable to calculate global count
.enum 0 export
OBJID.abstract.Iterator db
OBJID.abstract.Sort db
OBJID.abstract.Sprite db
OBJID.abstract.Background db
OBJID.abstract.Hdma db
OBJID.abstract.Script db
OBJID.abstract.Palette db
OBJID.Spc	db
OBJID.Script	db
OBJID.Msu1	db
OBJID.Msu1.audio	db
OBJID.Unit_test db
OBJID.Test_object db
OBJID.Iterator_test db
OBJID.Background.framebuffer db
OBJID.abstract.Event db
OBJID.Event.chapter db
OBJID.Event.hide_dash db
OBJID.Event.touch db
OBJID.Event.target db
OBJID.Event.checkpoint db
OBJID.Event.confirm db
OBJID.Event.show_help db
OBJID.Event.direction_right db
OBJID.Event.direction_left db
OBJID.Event.accelerate db
OBJID.Event.brake db
OBJID.Event.shake db
OBJID.Event.player_crash db
OBJID.Event.opponent_crash db
OBJID.Event.terrain_crash db
OBJID.Event.soft_crash db
OBJID.Event.landing_crash db
OBJID.Event.explode_crash db
OBJID.Event.slide_crash db
OBJID.Event.debris_crash db
OBJID.Event.wall_crash db
OBJID.Event.window_crash db
OBJID.Event.hide_sunscreen db
OBJID.Event.change_dash db
OBJID.Event.macro_vibrate1 db
OBJID.Event.macro_vibrate2 db
OBJID.Event.macro_vibrate3 db
OBJID.Event.macro_rockfast db
;OBJID.Zero db
OBJID.Right_arrow db
OBJID.Left_arrow db
OBJID.Turbo_icon db
OBJID.Brake_icon db
;OBJID.Dashboard db
OBJID.VideoMask db
OBJID.SteeringWheel db
OBJID.Background.generic db
OBJID.Brightness db
OBJID.Player db
OBJID.Pause db
OBJID.LogoZoom db
;OBJID.Persistency db
OBJID.Score db
OBJID.Background.textlayer.8x8 db
OBJID.Background.textlayer.16x16 db
OBJID.Sprite.super db
OBJID.Palette.rotate db
OBJID.Player.nameInput db
OBJID.Background.dashboard db
OBJID.Sprite.life_car db
OBJID.Sprite.life_counter db
OBJID.Sprite.score db
OBJID.Sprite.bang db
OBJID.Hdma.dashboard.mode db
MAXOBJID	ds 0
.ende


.base BSL
.bank 0 slot 0

;interfaces
.include "src/object/default/default.interface"
.include "src/object/dimension/dimension.interface"

.section "oop-class lut" superfree
OopClassLut:
	PTRLONG OopClassLut abstract.Iterator.CLS
	PTRLONG OopClassLut abstract.Sort.CLS
	PTRLONG OopClassLut abstract.Sprite.CLS
	PTRLONG OopClassLut abstract.Background.CLS
	PTRLONG OopClassLut abstract.Hdma.CLS
	PTRLONG OopClassLut abstract.Script.CLS
	PTRLONG OopClassLut abstract.Palette.CLS
	PTRLONG OopClassLut Spc.CLS
	PTRLONG OopClassLut Script.CLS
	PTRLONG OopClassLut Msu1.CLS
	PTRLONG OopClassLut Msu1.audio.CLS
	PTRLONG OopClassLut Unit_test.CLS
	PTRLONG OopClassLut Test_object.CLS
	PTRLONG OopClassLut Iterator_test.CLS
	PTRLONG OopClassLut Background.framebuffer.CLS
	PTRLONG OopClassLut abstract.Event.CLS
	PTRLONG OopClassLut Event.chapter.CLS
	PTRLONG OopClassLut Event.hide_dash.CLS
	PTRLONG OopClassLut Event.touch.CLS
	PTRLONG OopClassLut Event.target.CLS
	PTRLONG OopClassLut Event.checkpoint.CLS
	PTRLONG OopClassLut Event.confirm.CLS
	PTRLONG OopClassLut Event.show_help.CLS
	PTRLONG OopClassLut Event.direction_right.CLS
	PTRLONG OopClassLut Event.direction_left.CLS
	PTRLONG OopClassLut Event.accelerate.CLS
	PTRLONG OopClassLut Event.brake.CLS
	PTRLONG OopClassLut Event.shake.CLS
	PTRLONG OopClassLut Event.player_crash.CLS
	PTRLONG OopClassLut Event.opponent_crash.CLS
	PTRLONG OopClassLut Event.terrain_crash.CLS
	PTRLONG OopClassLut Event.soft_crash.CLS
	PTRLONG OopClassLut Event.landing_crash.CLS
	PTRLONG OopClassLut Event.explode_crash.CLS
	PTRLONG OopClassLut Event.slide_crash.CLS
	PTRLONG OopClassLut Event.debris_crash.CLS
	PTRLONG OopClassLut Event.wall_crash.CLS
	PTRLONG OopClassLut Event.window_crash.CLS
	PTRLONG OopClassLut Event.hide_sunscreen.CLS
	PTRLONG OopClassLut Event.change_dash.CLS
	PTRLONG OopClassLut Event.macro_vibrate1.CLS
	PTRLONG OopClassLut Event.macro_vibrate2.CLS
	PTRLONG OopClassLut Event.macro_vibrate3.CLS
	PTRLONG OopClassLut Event.macro_rockfast.CLS
	PTRLONG OopClassLut Right_arrow.CLS
	PTRLONG OopClassLut Left_arrow.CLS
	PTRLONG OopClassLut Turbo_icon.CLS
	PTRLONG OopClassLut Brake_icon.CLS
	PTRLONG OopClassLut VideoMask.CLS
	PTRLONG OopClassLut SteeringWheel.CLS
	PTRLONG OopClassLut Background.generic.CLS
	PTRLONG OopClassLut Brightness.CLS
	PTRLONG OopClassLut Player.CLS
	PTRLONG OopClassLut Pause.CLS
	PTRLONG OopClassLut LogoZoom.CLS
	PTRLONG OopClassLut Score.CLS
	PTRLONG OopClassLut Background.textlayer.8x8.CLS
	PTRLONG OopClassLut Background.textlayer.16x16.CLS
	PTRLONG OopClassLut Sprite.super.CLS
	PTRLONG OopClassLut Palette.rotate.CLS
	PTRLONG OopClassLut Player.nameInput.CLS
	PTRLONG OopClassLut Background.dashboard.CLS
	PTRLONG OopClassLut Sprite.life_car.CLS
	PTRLONG OopClassLut Sprite.life_counter.CLS
	PTRLONG OopClassLut Sprite.score.CLS
	PTRLONG OopClassLut Sprite.bang.CLS
	PTRLONG OopClassLut Hdma.dashboard.mode.CLS
.ends
